; snake snake
; (with some remnants of leod's bettersnake.asm)



        !State = !1594
        !Direction = !187B
        !NextDirection = $58
        !DirectionBuffer = $7FC720
        !OnGrid = $60
        !OnGridLastFrame = $61
        !Length = $62





; init

        print "INIT ", pc

        STZ !State,x
        STZ !OnGrid
        STZ !Length
        STZ $0DBF
        LDA #$04                                ; \  initialize the direction buffer
        STA !DirectionBuffer                    ; /  so the tail doesn't start moving on its own





; main

        print "MAIN ", pc

        PHB : PHK : PLB : JSR MainCode : PLB : RTL

Return:
        RTS





MainCode:

        JSR Graphics

        LDA $9D
        BNE Return





HandleActivation:

        LDA !State,x
        BNE .alreadyActive

        JSR GetDirectionFromButtons
        CMP #$FF                                ; \  no BMI because the subroutine ends in PLY
        BEQ .dontActivate                       ; /

.activate

        STA !Direction,x

        LDA #$01
        STA !State,x

.alreadyActive
.dontActivate

        LDA !State,x
        BNE .active
        RTS

.active





HandleGrowth:

        LDA !14E0,x                             ; \
        XBA                                     ;  |
        LDA !E4,x                               ;  | check current grid position
        REP #$20                                ;  |
        AND #$FFF0                              ;  |
        STA $9A                                 ;  |
        SEP #$20                                ;  |
                                                ;  |
        LDA !14D4,x                             ;  |
        XBA                                     ;  |
        LDA !D8,x                               ;  |
        REP #$20                                ;  |
        AND #$FFF0                              ;  |
        STA $98                                 ;  |
        SEP #$20                                ; /

        JSR CheckMap16                          ; \
        LDA [$05]                               ;  | if there's not a coin there, skip
        CMP #$2B                                ;  |
        BNE .dontGrow                           ; /



.grow
        LDA #$01                                ; \
        STA $9C                                 ;  | erase the coin to prevent contact for more than one frame
        JSL $00BEB0                             ; /

        PHX                                     ; \
        LDX !Length                             ;  | make the tail stop for one tile (=growing)
        LDA #$04                                ;  | (store #$04 = stop in the buffer at the right position)
        STA !DirectionBuffer,x                  ;  |
        PLX                                     ; /

        INC !Length                             ;    update the length (=buffer position the tail looks at)

        INC $13CC                               ;    add a coin since we've essentially collected one

        JSR Glitter
        
        LDA #$01                                ; \
        STA $1DFC                               ;  | play some sounds
        LDA #$06                                ;  |
        STA $1DF9                               ; /



.spawnNewCoin

..getRandomIndex

        LDA #$0F                                ; \
        JSL GetRandomNumber                     ;  |
        ASL #4                                  ;  | get a random position to spawn a new coin
        STA $9A                                 ;  |
        STZ $9B                                 ;  |
        LDA #$0D                                ;  |
        JSL GetRandomNumber                     ;  |
        ASL #4                                  ;  |
        REP #$20                                ;  |
        AND #$00FF                              ;  |
        CLC : ADC #$00C0                        ;  |
        STA $98                                 ;  |
        SEP #$20                                ; /

        JSR CheckMap16                          ; \
        LDA [$05]                               ;  | if there's not an empty tile there, choose another
        CMP #$25                                ;  | (making this non-deterministic, but eh)
        BNE ..getRandomIndex                    ; /

..spawn
        LDA #$06                                ; \
        STA $9C                                 ;  | spawn, spawn, hummingbird
        JSL $00BEB0                             ; /

        JSR Smoke

        

.dontGrow





HandleDirection:

        JSR GetDirectionFromButtons             ; \
        STA $0F                                 ;  |
        CMP #$FF                                ;  | if a new direction button is pressed,
        BEQ .dontApply                          ;  | save the new direction in an extra RAM address
        LDA !Length                             ;  | (this is so that input is taken every frame,
        BEQ .apply                              ;  | but only applied when the sprite is aligned with the grid)
        LDA $0F                                 ;  |
        CLC : ADC !Direction,x                  ;  | (don't allow moving in the opposite direction
        AND #$01                                ;  | unless the length is 1 [#$00])
        BEQ .dontApply                          ;  |
.apply                                          ;  |
        LDA $0F                                 ;  |
        STA !NextDirection                      ;  |
.dontApply                                      ; /





HandleEdgeCollision:

        LDA !Direction,x                        ; \
        CMP #$04                                ;  |
        BEQ .skip                               ;  | if the sprite is about to leave the screen, die
                                                ;  |
        LDA !14E0,x                             ;  | (separate from the "collision with self" handling
        XBA                                     ;  | because this should be checked every frame
        LDA !E4,x                               ;  | and with non-grid-aligned position values)
        REP #$20                                ;  |
        CMP #$00F1                              ;  |
        BCC +                                   ;  |
        SEP #$20 : JSL $00F606 : REP #$20       ;  |
+       SEP #$20                                ;  |
                                                ;  |
        LDA !14D4,x                             ;  |
        XBA                                     ;  |
        LDA !D8,x                               ;  |
        REP #$20                                ;  |
        CMP #$00C0                              ;  |
        BCC +                                   ;  |
        CMP #$0191                              ;  |
        BCC ++                                  ;  |
+       SEP #$20 : JSL $00F606                  ;  |
++      SEP #$20                                ;  |
                                                ;  |
.skip                                           ; /





CheckGrid:

        LDA !OnGrid                             ; \  update "on grid" flag for last frame
        STA !OnGridLastFrame                    ; /

        STZ !OnGrid                             ; \
        LDA !E4,x                               ;  | update "on grid" flag for current frame
        ORA !D8,x                               ;  |
        AND #$0F                                ;  |
        BNE .notOnGrid                          ;  |
.onGrid                                         ;  |
        INC !OnGrid                             ; /

        LDA !OnGridLastFrame                    ; \
        BEQ .isFirstFrame                       ;  | check if this is the first frame on the grid
        JMP .notFirstFrameOnGrid                ; /
.isFirstFrame



.updateDirection                                ; \
        LDA !NextDirection                      ;  | update the direction
        STA !Direction,x                        ; /



.spawnBlock

        LDA !14E0,x                             ; \
        XBA                                     ;  |
        LDA !E4,x                               ;  | spawn a brown block
        REP #$20                                ;  |
        AND #$FFF0                              ;  |
        STA $9A                                 ;  |
        SEP #$20                                ;  |
                                                ;  |
        LDA !14D4,x                             ;  |
        XBA                                     ;  |
        LDA !D8,x                               ;  |
        REP #$20                                ;  |
        AND #$FFF0                              ;  |
        STA $98                                 ;  |
        SEP #$20                                ;  |
                                                ;  |
        LDA #$0D                                ;  |
        STA $9C                                 ;  |
        JSL $00BEB0                             ; /



.updateDirectionBuffer

        PHX : LDX #222                          ; \
..loop                                          ;  |
        LDA !DirectionBuffer,x                  ;  | update the direction buffer --
        STA !DirectionBuffer+1,x                ;  | (a 224-byte long history of all directions the snake went,
        DEX                                     ;  | with the newest one at the top, effectively saving the path it took)
        CPX #$FF                                ;  | 
        BNE ..loop                              ;  | this is so the tail follows the same path as the head
        PLX                                     ;  |
                                                ;  | like the two blocks above, this is updated once per grid alignment
        LDA !Direction,x                        ;  |
        STA !DirectionBuffer                    ; /



.handleSelfCollision

        LDA !Direction,x
        CMP #$04
        BEQ .skip

        REP #$30                                ; \
        PHX                                     ;  |
        LDA !Direction,x                        ;  | look one tile ahead based on the current direction
        AND #$00FF                              ;  |
        ASL                                     ;  | (the correct values for $98+ were already set
        TAX                                     ;  | during the block spawning)
        LDA LookaheadXOffsets,x                 ;  |
        CLC : ADC $9A                           ;  |
        STA $9A                                 ;  |
        LDA LookaheadYOffsets,x                 ;  |
        CLC : ADC $98                           ;  |
        STA $98                                 ;  |
        PLX                                     ;  |
        SEP #$30                                ; /

        JSR CheckMap16                          ; \
        LDA [$05]                               ;  |
        CMP #$32                                ;  | if there's a brown block there, die
        BNE +                                   ;  |
        JSL $00F606                             ;  |
        +                                       ; /

.skip
.notFirstFrameOnGrid
.notOnGrid





UpdateSpeed:

        LDY !Direction,x
        LDA XSpeeds,y
        STA !B6,x
        LDA YSpeeds,y
        STA !AA,x

        JSL $01801A
        JSL $018022

        RTS





; graphics

Graphics:

        %GetDrawInfo()

        PHX

        LDA $00
        STA $0300|!Base2,y
        LDA $01
        DEC
        STA $0301|!Base2,y
        LDA #$2E
        STA $0302|!Base2,y
        LDA #$20
        STA $0303|!Base2,y

        PLX

        LDY #$02
        LDA #$00
        JSL $01B7B3

        RTS





CheckMap16:

        LDA $98                   
        AND #$F0                
        STA $06                   
        LDA $9A                   
        LSR #4                                           
        ORA $06                   
        PHA                      
        LDA $5B     
        AND #$01                
        BEQ .code01D977           
        PLA                       
        LDX $99                   
        CLC                       
        ADC $00BA80,x       
        STA $05                   
        LDA $00BABC,x       
        ADC $9B                   
        STA $06                   
        BRA .code01D989           
        
.code01D977
        PLA                       
        LDX $9B                   
        CLC                       
        ADC.l $00BA60,x       
        STA $05                   
        LDA.l $00BA9C,x       
        ADC $99                   
        STA $06                   
        
.code01D989
        LDA.b #$7E                
        STA $07                   
        LDX $15E9|!Base2
        RTS





GetDirectionFromButtons:

        PHY                                     ; \
        LDA $15                                 ;  |
        AND #$0F                                ;  | map button presses to snake-specific direction values
        TAY                                     ;  | (only when exactly one button is pressed, otherwise #$FF)
        LDA .dirs,y                             ;  |
        PLY                                     ;  |
        RTS                                     ; /
.dirs
        db $FF,$01,$03,$FF,$02,$FF,$FF,$FF
        db $00,$FF,$FF,$FF,$FF,$FF,$FF,$FF





Glitter:

        PHY
        LDY #$03
.loop
        LDA $17C0,y
        BEQ .createGlitter
        DEY
        BPL .loop
        PLY
        RTS

.createGlitter
        LDA #$05
        STA $17C0,y
        LDA $E4,x
        STA $17C8,y
        LDA $D8,x
        STA $17C4,y
        LDA #$10
        STA $17CC,y
.return
        PLY
        RTS





Smoke:

        PHY
        LDY #$03
.loop
        LDA $17C0,y
        BEQ .createSmoke
        DEY
        BPL .loop
        PLY
        RTS

.createSmoke
        LDA #$01
        STA $17C0,y
        LDA $9A
        STA $17C8,y
        LDA $98
        STA $17C4,y
        LDA #$10
        STA $17CC,y
.return
        PLY
        RTS





GetRandomNumber:                                ;    rng by 1024

        PHX
        PHP
        SEP #$30
        PHA
        JSL $01ACF9
        PLX
        CPX #$FF
        BNE .normal
        LDA $148B
        BRA .return
.normal
        INX
        LDA $148B
        STA $4202
        STX $4203
        NOP #4
        LDA $4217       
.return
        PLP
        PLX
        RTL





        ;   u   r   d   l   0

XSpeeds:
        db $00,$10,$00,-$10,$00
YSpeeds:
        db -$10,$00,$10,$00,$00



LookaheadXOffsets:
        dw $0000,$0010,$0000,-$0010,$0000
LookaheadYOffsets:
        dw -$0010,$0000,$0010,$0000,$0000
